/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

// 导入所需的类
import android.database.Cursor;
import android.util.Log;
import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.gtask.exception.ActionFailureException;
import net.micode.notes.tool.GTaskStringUtils;
import org.json.JSONException;
import org.json.JSONObject;
import java.util.ArrayList;

// TaskList类继承自Node类，表示一个任务列表
public class TaskList extends Node {
    // 定义日志标签
    private static final String TAG = TaskList.class.getSimpleName();

    // 任务列表的索引
    private int mIndex;

    // 存储子任务的列表
    private ArrayList<Task> mChildren;

    // TaskList的构造函数，初始化子任务列表和索引
    public TaskList() {
        super();
        mChildren = new ArrayList<Task>();
        mIndex = 1; // 默认索引为1
    }

    // 获取创建任务列表的JSON对象
    public JSONObject getCreateAction(int actionId) {
        JSONObject js = new JSONObject(); // 创建一个新的JSON对象

        try {
            // 设置动作类型为创建
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_CREATE);

            // 设置动作ID
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            // 设置索引
            js.put(GTaskStringUtils.GTASK_JSON_INDEX, mIndex);

            // 创建实体的变化对象
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName()); // 设置名称
            entity.put(GTaskStringUtils.GTASK_JSON_CREATOR_ID, "null"); // 创建者ID
            entity.put(GTaskStringUtils.GTASK_JSON_ENTITY_TYPE,
                    GTaskStringUtils.GTASK_JSON_TYPE_GROUP); // 实体类型
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity); // 将实体变化对象放入主对象中

        } catch (JSONException e) {
            Log.e(TAG, e.toString()); // 打印错误日志
            e.printStackTrace();
            throw new ActionFailureException("fail to generate tasklist-create jsonobject"); // 抛出异常
        }

        return js; // 返回生成的JSON对象
    }

    // 获取更新任务列表的JSON对象
    public JSONObject getUpdateAction(int actionId) {
        JSONObject js = new JSONObject(); // 创建一个新的JSON对象

        try {
            // 设置动作类型为更新
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_TYPE,
                    GTaskStringUtils.GTASK_JSON_ACTION_TYPE_UPDATE);

            // 设置动作ID
            js.put(GTaskStringUtils.GTASK_JSON_ACTION_ID, actionId);

            // 设置任务列表ID
            js.put(GTaskStringUtils.GTASK_JSON_ID, getGid());

            // 创建实体的变化对象
            JSONObject entity = new JSONObject();
            entity.put(GTaskStringUtils.GTASK_JSON_NAME, getName()); // 设置名称
            entity.put(GTaskStringUtils.GTASK_JSON_DELETED, getDeleted()); // 设置删除状态
            js.put(GTaskStringUtils.GTASK_JSON_ENTITY_DELTA, entity); // 将实体变化对象放入主对象中

        } catch (JSONException e) {
            Log.e(TAG, e.toString()); // 打印错误日志
            e.printStackTrace();
            throw new ActionFailureException("fail to generate tasklist-update jsonobject"); // 抛出异常
        }

        return js; // 返回生成的JSON对象
    }

    // 根据远程JSON设置任务列表的内容
    public void setContentByRemoteJSON(JSONObject js) {
        if (js != null) {
            try {
                // 设置任务列表ID
                if (js.has(GTaskStringUtils.GTASK_JSON_ID)) {
                    setGid(js.getString(GTaskStringUtils.GTASK_JSON_ID));
                }

                // 设置最后修改时间
                if (js.has(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED)) {
                    setLastModified(js.getLong(GTaskStringUtils.GTASK_JSON_LAST_MODIFIED));
                }

                // 设置名称
                if (js.has(GTaskStringUtils.GTASK_JSON_NAME)) {
                    setName(js.getString(GTaskStringUtils.GTASK_JSON_NAME));
                }

            } catch (JSONException e) {
                Log.e(TAG, e.toString()); // 打印错误日志
                e.printStackTrace();
                throw new ActionFailureException("fail to get tasklist content from jsonobject"); // 抛出异常
            }
        }
    }

    // 根据本地JSON设置任务列表的内容
    public void setContentByLocalJSON(JSONObject js) {
        // 检查JSON对象是否有效
        if (js == null || !js.has(GTaskStringUtils.META_HEAD_NOTE)) {
            Log.w(TAG, "setContentByLocalJSON: nothing is avaiable"); // 发出警告日志
        }

        try {
            // 获取任务列表的文件夹对象
            JSONObject folder = js.getJSONObject(GTaskStringUtils.META_HEAD_NOTE);

            // 根据文件夹类型设置名称
            if (folder.getInt(NoteColumns.TYPE) == Notes.TYPE_FOLDER) {
                String name = folder.getString(NoteColumns.SNIPPET);
                setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + name); // 设置文件夹名称
            } else if (folder.getInt(NoteColumns.TYPE) == Notes.TYPE_SYSTEM) {
                // 检查系统文件夹ID并设置相应名称
                if (folder.getLong(NoteColumns.ID) == Notes.ID_ROOT_FOLDER)
                    setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX + GTaskStringUtils.FOLDER_DEFAULT);
                else if (folder.getLong(NoteColumns.ID) == Notes.ID_CALL_RECORD_FOLDER)
                    setName(GTaskStringUtils.MIUI_FOLDER_PREFFIX
                            + GTaskStringUtils.FOLDER_CALL_NOTE);
                else
                    Log.e(TAG, "invalid system folder"); // 打印错误日志
            } else {
                Log.e(TAG, "error type"); // 打印错误日志
            }
        } catch (JSONException e) {
            Log.e(TAG, e.toString()); // 打印错误日志
            e.printStackTrace();
        }
    }

    // 从内容生成本地JSON对象
    public JSONObject getLocalJSONFromContent() {
        try {
            JSONObject js = new JSONObject(); // 创建一个新的JSON对象
            JSONObject folder = new JSONObject(); // 创建文件夹的JSON对象

            String folderName = getName(); // 获取任务列表名称
            if (getName().startsWith(GTaskStringUtils.MIUI_FOLDER_PREFFIX))
                folderName = folderName.substring(GTaskStringUtils.MIUI_FOLDER_PREFFIX.length(),
                        folderName.length()); // 去掉前缀

            // 设置文件夹名称和类型
            folder.put(NoteColumns.SNIPPET, folderName);
            if (folderName.equals(GTaskStringUtils.FOLDER_DEFAULT)
                    || folderName.equals(GTaskStringUtils.FOLDER_CALL_NOTE))
                folder.put(NoteColumns.TYPE, Notes.TYPE_SYSTEM);
            else
                folder.put(NoteColumns.TYPE, Notes.TYPE_FOLDER);

            js.put(GTaskStringUtils.META_HEAD_NOTE, folder); // 将文件夹对象放入主对象中

            return js; // 返回生成的JSON对象
        } catch (JSONException e) {
            Log.e(TAG, e.toString()); // 打印错误日志
            e.printStackTrace();
            return null; // 出现异常时返回null
        }
    }

    // 获取同步操作
    public int getSyncAction(Cursor c) {
        try {
            if (c.getInt(SqlNote.LOCAL_MODIFIED_COLUMN) == 0) {
                // 本地没有更新
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 本地和远程都没有更新
                    return SYNC_ACTION_NONE; // 返回无操作
                } else {
                    // 将远程应用到本地
                    return SYNC_ACTION_UPDATE_LOCAL;
                }
            } else {
                // 校验任务ID
                if (!c.getString(SqlNote.GTASK_ID_COLUMN).equals(getGid())) {
                    Log.e(TAG, "gtask id doesn't match"); // 打印错误日志
                    return SYNC_ACTION_ERROR; // 返回错误状态
                }
                if (c.getLong(SqlNote.SYNC_ID_COLUMN) == getLastModified()) {
                    // 仅本地修改
                    return SYNC_ACTION_UPDATE_REMOTE;
                } else {
                    // 对于文件夹冲突，采用本地修改
                    return SYNC_ACTION_UPDATE_REMOTE;
                }
            }
        } catch (Exception e) {
            Log.e(TAG, e.toString()); // 打印错误日志
            e.printStackTrace();
        }

        return SYNC_ACTION_ERROR; // 出现异常时返回错误状态
    }

    // 获取子任务数量
    public int getChildTaskCount() {
        return mChildren.size(); // 返回子任务列表大小
    }

    // 添加子任务
    public boolean addChildTask(Task task) {
        boolean ret = false;
        if (task != null && !mChildren.contains(task)) {
            ret = mChildren.add(task); // 尝试添加任务
            if (ret) {
                // 需要设置前一个兄弟任务和父任务
                task.setPriorSibling(mChildren.isEmpty() ? null : mChildren
                        .get(mChildren.size() - 1));
                task.setParent(this); // 设置父任务
            }
        }
        return ret; // 返回添加结果
    }

    // 根据索引添加子任务
    public boolean addChildTask(Task task, int index) {
        if (index < 0 || index > mChildren.size()) {
            Log.e(TAG, "add child task: invalid index"); // 打印错误日志
            return false; // 返回失败
        }

        int pos = mChildren.indexOf(task); // 查找任务在列表中的位置
        if (task != null && pos == -1) {
            mChildren.add(index, task); // 根据索引添加任务

            // 更新任务列表
            Task preTask = null;
            Task afterTask = null;
            if (index != 0)
                preTask = mChildren.get(index - 1); // 获取前一个任务
            if (index != mChildren.size() - 1)
                afterTask = mChildren.get(index + 1); // 获取后一个任务

            task.setPriorSibling(preTask); // 设置前一个兄弟任务
            if (afterTask != null)
                afterTask.setPriorSibling(task); // 设置后一个兄弟任务
        }

        return true; // 返回成功
    }

    // 移除子任务
    public boolean removeChildTask(Task task) {
        boolean ret = false;
        int index = mChildren.indexOf(task); // 查找任务在列表中的位置
        if (index != -1) {
            ret = mChildren.remove(task); // 尝试移除任务

            if (ret) {
                // 重置前一个兄弟任务和父任务
                task.setPriorSibling(null);
                task.setParent(null);

                // 更新任务列表
                if (index != mChildren.size()) {
                    mChildren.get(index).setPriorSibling(
                            index == 0 ? null : mChildren.get(index - 1)); // 更新前一个兄弟任务
                }
            }
        }
        return ret; // 返回移除结果
    }

    // 移动子任务
    public boolean moveChildTask(Task task, int index) {
        if (index < 0 || index >= mChildren.size()) {
            Log.e(TAG, "move child task: invalid index"); // 打印错误日志
            return false; // 返回失败
        }

        int pos = mChildren.indexOf(task); // 查找任务在列表中的位置
        if (pos == -1) {
            Log.e(TAG, "move child task: the task should in the list"); // 打印错误日志
            return false; // 返回失败
        }

        if (pos == index)
            return true; // 位置不变返回成功
        return (removeChildTask(task) && addChildTask(task, index)); // 移除并重新添加任务
    }

    // 根据GID查找子任务
    public Task findChildTaskByGid(String gid) {
        for (int i = 0; i < mChildren.size(); i++) {
            Task t = mChildren.get(i);
            if (t.getGid().equals(gid)) {
                return t; // 找到任务返回
            }
        }
        return null; // 未找到返回null
    }

    // 获取子任务索引
    public int getChildTaskIndex(Task task) {
        return mChildren.indexOf(task); // 返回任务在列表中的位置
    }

    // 根据索引获取子任务
    public Task getChildTaskByIndex(int index) {
        if (index < 0 || index >= mChildren.size()) {
            Log.e(TAG, "getTaskByIndex: invalid index"); // 打印错误日志
            return null; // 返回null
        }
        return mChildren.get(index); // 返回任务
    }

    // 根据GID获取子任务
    public Task getChilTaskByGid(String gid) {
        for (Task task : mChildren) {
            if (task.getGid().equals(gid))
                return task; // 找到任务返回
        }
        return null; // 未找到返回null
    }

    // 获取子任务列表
    public ArrayList<Task> getChildTaskList() {
        return this.mChildren; // 返回子任务列表
    }

    // 设置索引
    public void setIndex(int index) {
        this.mIndex = index; // 设置任务列表索引
    }

    // 获取索引
    public int getIndex() {
        return this.mIndex; // 返回任务列表索引
    }
}
